# coding=utf-8
#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
Created on 2020-01-01
@author: nayuan
'''

import json

from longmao.api.Api import Api
from longmao.core.exception.Exception import RequestException

class ApiProjectCreate(Api):

    def __init__(self):
        super(ApiProjectCreate, self).__init__('longmao.project.create', '20200101')

        self._title = None
        self._desc = None
        self._type = None
        self._labels = None
        self._callback_url = None

    @property
    def title(self):
        return self._title

    @title.setter
    def title(self, value):
        self._title = value

    @property
    def desc(self):
        return self._desc

    @desc.setter
    def desc(self, value):
        self._desc = value

    @property
    def type(self):
        return self._type

    @type.setter
    def type(self, value):
        self._type = value

    @property
    def labels(self):
        return self._labels

    @labels.setter
    def labels(self, value):
        self._labels = value

    @property
    def callback_url(self):
        return self._callback_url

    @callback_url.setter
    def callback_url(self, value):
        self._callback_url = value


    def get_params(self):

        if not self._title or not self._title.strip():
            raise RequestException("项目名称[title]不能为空")
        if not self._desc or not self._desc.strip():
            raise RequestException("项目描述[desc]不能为空")
        if not self._type or not self._type.strip():
            raise RequestException("项目类型[type]不能为空")

        data = dict()
        data['title'] = self._title
        data['desc'] = self._desc
        data['type'] = self._type
        if self._labels:
            data['labels'] = json.dumps(self._labels)
        if self._callback_url:
            data['callback_url'] = self._callback_url
        return data
