# coding=utf-8
#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
Created on 2020-01-01
@author: nayuan
'''

from longmao.api.Api import Api
from longmao.core.exception.Exception import RequestException

class ApiProjectTaskList(Api):

    def __init__(self):
        super(ApiProjectTaskList, self).__init__('longmao.project.task.list', '20200101')
        self._project_id = None
        self._callback_status = None
        self._callback_time = None
        self._page = 1

    @property
    def project_id(self):
        return self._project_id

    @project_id.setter
    def project_id(self, value):
        self._project_id = value

    @property
    def callback_status(self):
        return self._callback_status

    @callback_status.setter
    def callback_status(self, value):
        self._callback_status = value

    @property
    def callback_time(self):
        return self._callback_time

    @callback_time.setter
    def callback_time(self, value):
        self._callback_time = value

    @property
    def page(self):
        return self._page

    @page.setter
    def page(self, value):
        self._page = value

    def get_params(self):

        if not self._project_id or not self._project_id.strip():
            raise RequestException("项目ID[project_id]不能为空")
        if not self._callback_status or not self._callback_status.strip():
            raise RequestException("回调状态[callback_status]不能为空")

        data = dict()
        data['project_id'] = self._project_id
        data['page'] = self._page
        data['callback_status'] = self._callback_status
        if self._callback_time:
            data['callback_time'] = self._callback_time
        return data
