# coding=utf-8
#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
Created on 2020-01-01
@author: nayuan
'''

import json

from longmao.api.Api import Api
from longmao.core.exception.Exception import RequestException


class ApiProjectUpdate(Api):

    def __init__(self):
        super(ApiProjectUpdate, self).__init__('longmao.project.update', '20200101')

        self._id = None
        self._desc = None
        self._labels = None
        self._callback_url = None

    @property
    def id(self):
        return self._id

    @id.setter
    def id(self, value):
        self._id = value

    @property
    def desc(self):
        return self._desc

    @desc.setter
    def desc(self, value):
        self._desc = value

    @property
    def labels(self):
        return self._labels

    @labels.setter
    def labels(self, value):
        self._labels = value

    @property
    def callback_url(self):
        return self._callback_url

    @callback_url.setter
    def callback_url(self, value):
        self._callback_url = value


    def get_params(self):

        if not self._desc or not self._desc.strip():
            raise RequestException("项目描述[desc]不能为空")

        data = dict()
        data['id'] = self._id
        data['desc'] = self._desc
        if self._labels:
            data['labels'] = json.dumps(self._labels)
        if self._callback_url:
            data['callback_url'] = self._callback_url
        return data
